﻿Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Drawing
Imports System.Drawing.Printing
Imports PDFCreatorPilotLib

Module Module1
    Sub Main()
        Dim printername As String = DefaultPrinterName()
        Dim filename As String = "test.pdf"
        PrintPDF(filename, printername)
    End Sub
    Private Function DefaultPrinterName() As String
        Dim functionReturnValue As String = Nothing
        Dim oPS As New System.Drawing.Printing.PrinterSettings()
        Try
            functionReturnValue = oPS.PrinterName
        Catch ex As System.Exception
            functionReturnValue = ""
        Finally
            oPS = Nothing
        End Try
        Return functionReturnValue
    End Function
    Private doc As New PrintDocument()
    Private iPage As Integer
    Private pdf As PDFCreatorPilotLib.PDFDocument4Class
    Private Sub doc_PrintPage(ByVal sender As Object, ByVal e As PrintPageEventArgs)
        Dim logpixelsx As Single = e.Graphics.DpiX
        Dim logpixelsy As Single = e.Graphics.DpiY
        Dim resolution As Long = pdf.PageResolution
        Dim zoomX As Single = resolution / logpixelsx
        Dim zoomY As Single = resolution / logpixelsy
        pdf.DrawPageToDC(e.Graphics.GetHdc, iPage - 1, zoomX, zoomY, True)
        System.Math.Max(System.Threading.Interlocked.Increment(iPage), iPage - 1)
        e.HasMorePages = (iPage < pdf.GetPageCount())
    End Sub
    Public Function PrintPDF(ByVal filename As [String], ByVal printername As [String]) As Integer
        pdf = New PDFCreatorPilotLib.PDFDocument4Class()
        pdf.Open(filename, "")
        doc.DocumentName = filename
        doc.PrinterSettings.PrinterName = printername
        AddHandler doc.PrintPage, AddressOf doc_PrintPage
        iPage = 1
        doc.Print()
        RemoveHandler doc.PrintPage, AddressOf doc_PrintPage
        Return 0
    End Function
End Module